/* This file is part of zooming_stickies.

   Copyright 2012 Sukru Cinar

   Distributed under the GPLv3 licence. Please see the file 
   'gpl-3.0.txt' for more details. */
#line 70 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

#include <stdio.h>
#include <xincs.h>
#include <fxver.h>
#include <fxdefs.h>
#include <FXHash.h>
#include <FXThread.h>
#include <FXStream.h>
#include <FXString.h>
#include <FXRectangle.h>
#include <FXRegistry.h>
#include <FXApp.h>
#include <FXDCWindow.h>
#include <FXFont.h>
#include <fxkeys.h>
#include "graphview.h"
#include "words.h"
#include "square_layout.h"

// Required for the mouse module
#define CLASSNAME GraphView 


using namespace FX;

FXDEFMAP(GraphView) graphviewEventMap[]={
  FXMAPFUNC(SEL_PAINT,0,GraphView::onPaint),
#line 591 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
  FXMAPFUNC(SEL_MOUSEWHEEL,0, GraphView::onMouseWheel),

#line 1055 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
  FXMAPFUNC(SEL_COMMAND, GraphView::ID_NODETEXT_OK, GraphView::ok_nodetext),
  FXMAPFUNC(SEL_COMMAND, GraphView::ID_NODETEXT_CANCEL, GraphView::cancel_nodetext),

#line 1241 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

FXMAPFUNC(SEL_KEYPRESS, GraphView::ID_NODETEXT, GraphView::nodetext_key),

#line 10 "/home/dodo/SFP/zooming_stickies-1.0/src/mouse.u"

  FXMAPFUNC(SEL_LEFTBUTTONPRESS,0, CLASSNAME::onLeftBtnPress),
  FXMAPFUNC(SEL_LEFTBUTTONRELEASE,0, CLASSNAME::onLeftBtnRelease),
  FXMAPFUNC(SEL_MOTION,0, CLASSNAME::onMotion),

#line 98 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
  //FXMAPFUNC(SEL_KEYPRESS, 0, GraphView::onKeyPress),
};

FXIMPLEMENT(GraphView,FXComposite,graphviewEventMap,
            ARRAYNUMBER(graphviewEventMap))

#line 53 "graphview.cc"

static int box_intersect(box_t *A, box_t *B);
static int max(int a,int b) ;
#line 107 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

#line 198 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

static int box_intersect(box_t *A, box_t *B)
{
  return (A->right-B->left)*(B->right-A->left) > 0 &&
         (A->bottom-B->top)*(B->bottom-A->top) > 0;
}

#line 498 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

static int max(int a,int b) { return a>b? a:b; }

#line 109 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

GraphView::GraphView(){ flags|=FLAG_ENABLED|FLAG_SHOWN; }

GraphView::GraphView
     (FXComposite* p, FXObject *tgt, int sel, FXuint opts,
     FXint x,FXint y,FXint w,FXint h):
            FXComposite(p,opts,x,y,w,h)
{
   flags|=FLAG_ENABLED | FLAG_SHOWN;
#line 215 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

  n_boxes= 0;
  s_boxes= 500;
  boxes= (box_t**) malloc(sizeof(box_t*)*s_boxes);

#line 234 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

  shik= 10.0;

#line 431 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

  default_font= make_font(12.0);

#line 511 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

  font_map= new std::map<int,FXFont*>();

#line 621 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

  max_x= max_y= INT_MIN; min_x= min_y= INT_MAX;

#line 730 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

  dragging_box= 0;

#line 893 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

 selected_box= 0;

#line 1037 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

 text_frame= new FXVerticalFrame(this, FRAME_RAISED |
                     LAYOUT_FIX_X | LAYOUT_FIX_Y |
                     LAYOUT_FIX_WIDTH | LAYOUT_FIX_HEIGHT, 
                     0,0, 200, 100, DEFAULT_SPACING, DEFAULT_SPACING, DEFAULT_SPACING, DEFAULT_SPACING, 0,0);
 node_text= new FXText(text_frame, this,ID_NODETEXT, TEXT_WORDWRAP |
                                  LAYOUT_FILL_Y | LAYOUT_FILL_X);
 FXHorizontalFrame *hf= new FXHorizontalFrame(text_frame, LAYOUT_FILL_X,
                   0,0,0,0, 0,0,0,0, 0,0);
 new FXButton(hf,  "OK", 0, this, ID_NODETEXT_OK, BUTTON_NORMAL | LAYOUT_LEFT);
 new FXButton(hf,  "Cancel", 0, this, ID_NODETEXT_CANCEL,
                                             BUTTON_NORMAL | LAYOUT_RIGHT);
 text_frame->hide();

#line 1112 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

  editing_box= 0;

#line 1530 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

  modified= 0;
#line 30 "/home/dodo/SFP/zooming_stickies-1.0/src/mouse.u"

  last_mouse_x=0, last_mouse_y=0;
  click_mouse_x=0, click_mouse_y=0;
  mouse_down= 0;

#line 119 "/home/dodo/SFP/zooming_stickies-1.0/src/mouse.u"
 dragging= 0;

#line 120 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
  pos_x= 0; pos_y= 0; // transitioned from FXScrollArea
  target= tgt;
  message= sel;
}


bool GraphView::canFocus() const { return true; }

int GraphView::getDefaultWidth() { return 0; }
int GraphView::getDefaultHeight() { return 0; }

void GraphView::create() {
	FXComposite::create();
#line 435 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

  default_font->create();
  default_font_height= default_font->getFontHeight();
  default_font_space= default_font->getTextWidth(" ", 1);
  default_font_ascent= default_font->getFontAscent();
#line 134 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
}

void GraphView::detach() { FXComposite::detach(); }

GraphView::~GraphView() { }


void GraphView::layout() {
   FXComposite::layout();
   update_scroller();
}

#line 248 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
void GraphView::screen_coords(int doc_x, int doc_y, int *scr_x, int *scr_y) 
{
  *scr_y = doc_y / shik - pos_y;  
  *scr_x = doc_x / shik - pos_x;
}

void GraphView::document_coords(int scr_x, int scr_y, int *doc_x, int *doc_y)
{
  *doc_x= (scr_x + pos_x) * shik;
  *doc_y= (scr_y + pos_y) * shik;
}

#line 264 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

long GraphView::onPaint(FXObject* ob,FXSelector sel,void* ptr){
  FXEvent* event=(FXEvent*)ptr;
  FXDCWindow dc(this,event);

#line 289 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

  box_t event_box;
  bgclip_t *bgc;

  document_coords(event->rect.x, event->rect.y, 
          &event_box.left, &event_box.top);
  document_coords(event->rect.x+event->rect.w-1,
                  event->rect.y+ event->rect.h-1,
          &event_box.right, &event_box.bottom);

  bgc= bgclip_start(0, event->rect.x, event->rect.y,
                       event->rect.x+event->rect.w-1,
                       event->rect.y+event->rect.h-1);

  int left,top, right, bottom;
  int i;
  for(i=0;i<n_boxes;i++)
     if (box_intersect(&event_box, boxes[i]))
     {
       screen_coords(boxes[i]->left, boxes[i]->top, &left, &top);
       screen_coords(boxes[i]->right, boxes[i]->bottom, &right, &bottom);
       draw_box(&dc,boxes[i]);
       bgclip_remove(bgc, left, top, right, bottom);
     }

  FXColor white;
  white= FXRGB(0xff,0xff,0xff);
  dc.setForeground(white);
  while(bgclip_get(bgc,&left,&top,&right,&bottom))
    dc.fillRectangle(left, top, right-left+1, bottom-top+1);

  bgclip_free(bgc);

#line 270 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
  draw_selection(&dc);
  return 1;
}

#line 330 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

void GraphView::draw_box(FXDCWindow *dc, box_t *box)
{
  int left, right, top, bottom;
  dc->setForeground(box->color);
  screen_coords(box->left, box->top, &left, &top);
  screen_coords(box->right, box->bottom, &right, &bottom);
  dc->fillRectangle(left, top, right-left+1, bottom-top+1);

  if (box->font_size/shik <= 3.0) return ;
  if (box->font_size/shik >= 200.0) return ;

  FXColor black;
  black= FXRGB(0,0,0);
  dc->setBackground(box->color);
  dc->setForeground(black);

  dc->setFont(get_font(box->font_size/shik));

  int x_text, y_text;

  screen_coords(box->text_x, box->text_y_baseline, &x_text, &y_text);
  int i;
  for(i=0;box->rows[i];i++)
  {
    int L= strlen(box->rows[i]);
    dc->drawImageText(x_text, y_text, box->rows[i], L);
    y_text += box->font_size/shik / 12.0 * default_font_height;
  }
}

#line 372 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

#line 378 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

void GraphView::mouse_release_action()
{
  dragging_box= 0;
}


#line 394 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

void GraphView::zoom_in()
{
  if (shik>1.1) { shik *= 0.9; }
  else { shik= 1.0; }
  update();
}

void GraphView::zoom_out()
{
  shik /= 0.9;
  update();
}

#line 448 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

FXFont *GraphView::make_font(double size)
{
  FXFontDesc desc;
  strcpy(desc.face, "Times");
  desc.size= size*10;
  desc.weight= FXFont::Normal;
  desc.slant= FXFont::Straight;
  desc.setwidth= FXFont::NonExpanded;
  desc.encoding= FONTENCODING_UNICODE;
  desc.flags= FXFont::Scalable | FXFont::Roman;
  return new FXFont(FXApp::instance(), desc);
}

#line 471 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

box_t* GraphView::create_box(int X,int Y, FXColor color, char *text)
{
  box_t *box;
  box= (box_t*) malloc(sizeof(box_t));
  box->color= color;
  box->text= strdup(text);
  box->font_size= 12*shik;

  if (n_boxes==s_boxes) 
  {
    s_boxes+= s_boxes/2;
    boxes= (box_t**) realloc(boxes, sizeof(box_t*)*s_boxes);
  }
  boxes[n_boxes++]= box;

  layout_text(box, X,Y);

  update_box(box, FALSE);
  update_max_coords(box);

  modified= 1;
  
  return box;
}

#line 524 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

FXFont *GraphView::get_font(double size)
{
  int key;
  FXFont *f;
  std::map<int,FXFont*>::iterator it;
  key= size*10;
  it= font_map->find(key);
  if (it!=font_map->end()) return it->second;

  f= make_font(size);
  font_map->insert(std::pair<int,FXFont*>(key, f));
  f->create();
  return f;
}

#line 556 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

void GraphView::zoom(double f,int x, int y)
{
   int doc_x, doc_y;
   double x_ratio, y_ratio;

   document_coords(x,y,&doc_x, &doc_y);

   x_ratio= (double)x/getWidth();
   y_ratio= (double)y/getHeight();

   shik *= f;

   if (!n_boxes) return ;

   double Hwin, Wwin;

   Wwin= getWidth()*shik;
   Hwin= getHeight()*shik;

   pos_x= (doc_x - x_ratio * Wwin)/shik;
   pos_y= (doc_y - y_ratio * Hwin)/shik;

   update_scroller();
   update();
}

#line 594 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

long GraphView::onMouseWheel(FXObject* ob,FXSelector sel,void* ptr)
{
  FXEvent* event=(FXEvent*)ptr;
  int event_x= event->win_x, event_y= event->win_y;

  if (event->code > 0) zoom(0.9, event_x, event_y);
  else zoom(1.1, event_x, event_y);
  return 1;
}

#line 635 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
void GraphView::update_scroller()
{
  int A[8];
  int i= 0;


  A[i++]= scroller->WSx= pos_x * shik;
  A[i++]= scroller->WSy= pos_y * shik;
  A[i++]= scroller->WLx= (pos_x + getWidth()-1)*shik;
  A[i++]= scroller->WLy= (pos_y + getHeight()-1)*shik;

  if (n_boxes) 
  {
    A[i++]= scroller->DSx= min_x;
    A[i++]= scroller->DSy= min_y;
    A[i++]= scroller->DLx= max_x;
    A[i++]= scroller->DLy= max_y;
  } else {
     A[i++]= scroller->DSx= scroller->WSx;
     A[i++]= scroller->DSy= scroller->WSy;
     A[i++]= scroller->DLx= scroller->WLx;
     A[i++]= scroller->DLy= scroller->WLy;
  }
  scroller->update();
}
#line 672 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

void GraphView::show_request(int x,int y)
{
  int W,H;
  if (!n_boxes) return ;
  W= getWidth(); H= getHeight();
  x/= shik; y/= shik;
     // already on screen
  if (x-pos_x > 50 && pos_x+W-x>50 &&
      y-pos_y > 50 && pos_y+H-y>50) return ;

  int Mx,My,mx,my; // M= max m= min
  int px, py;     // posx posy

  Mx= max_x / shik; My= max_y /shik;
  mx= min_x / shik; my= min_y /shik;
  px= x - W/2; py= y-H/2;

  if (px<mx) px= mx;
  if (py<my) py= my;

  if (px+W > Mx && px!=mx) px= Mx - W;
  if (py+H > My && py!=my) py= My - H;
  pos_x= px;
  pos_y= py;
  update();
  update_scroller();
}
#line 715 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

int GraphView::drag_start(int x,int y)
{
  dragging_box= find_box_screen(x,y);
  if (dragging_box) return 1;
  return 0;
}
#line 741 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
void GraphView::motion_action(int old_x,int old_y, int x,int y)
{
  if (!dragging_box) return ;
  int top, left, right, bottom;
  screen_coords(dragging_box->left, dragging_box->top, &left, &top);
  screen_coords(dragging_box->right, dragging_box->bottom, &right, &bottom);
  update(left-5, top-5, right-left+1+10, bottom-top+1+10);

  int dx, dy;
  dx= x - old_x;
  dy= y - old_y;

  double W,H,B;
  W= dragging_box->right - dragging_box->left;
  H= dragging_box->bottom- dragging_box->top;
  B= dragging_box->text_y_baseline - dragging_box->top;

  dragging_box->left+= dx*shik;
  dragging_box->right= dragging_box->left + W;
  dragging_box->text_x+= dx*shik;

  dragging_box->top+= dy*shik;
  dragging_box->bottom= dragging_box->top + H;
  dragging_box->text_y_baseline= dragging_box->top + B;

  screen_coords(dragging_box->left, dragging_box->top, &left, &top);
  screen_coords(dragging_box->right, dragging_box->bottom, &right, &bottom);
  update(left-5, top-5, right-left+1+10, bottom-top+1+10);

  update_max_coords(dragging_box);
  modified= 1;
}
 
#line 783 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

void GraphView::update_max_coords(box_t *B)
{
  int change= 0;
  if (B->left<min_x) { min_x= B->left; change=1; }
  if (B->top<min_y) { min_y= B->top; change=1; }

  if (B->right>max_x) { max_x= B->right; change=1; }
  if (B->bottom>max_y) { max_y= B->bottom; change=1; }

  if (change) update_scroller();
}

#line 806 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

void GraphView::pan_request(int dx,int dy)
{
   int px, py;

   px= pos_x*shik + dx;
   py= pos_y*shik + dy;

   if (px<min_x) px= min_x;
   if (py<min_y) py= min_y;

   if (px+getWidth()*shik>max_x && px!=min_x) px= max_x - getWidth()*shik;
   if (py+getHeight()*shik>max_y && py!=min_y) py= max_y - getHeight()*shik;

   int Wscr= getWidth()*shik, Hscr= getHeight()*shik;
   int Wx= pos_x*shik, Wy= pos_y*shik;

   if (Wx<=min_x && Wx+Wscr>=max_x) px= pos_x*shik;
   if (Wy<=min_y && Wy+Hscr>=max_y) py= pos_y*shik;

   if (px!=pos_x*shik || py!=pos_y*shik) {
     pos_x= px/shik; pos_y= py/shik;
     update();
     update_scroller();
   }
}

#line 845 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

void GraphView::doubleclick_action(int x,int y)
{
    box_t *B;
    int a[2];

    B= find_box_screen(x,y);
    if (B) {
      if (target)
        target->tryHandle(this, FXSEL(SEL_COMMAND,message+ID_DCLICK_NODE), B);
      return ;
    }
    document_coords(x,y, a+0, a+1);
    if (target)
       target->tryHandle(this, FXSEL(SEL_COMMAND,message+ID_DCLICK_SPACE), a);
}

#line 870 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
box_t *GraphView::find_box_screen(int x,int y)
{
    int doc_x, doc_y;
    int i;
    document_coords(x,y, &doc_x, &doc_y);
    for(i=0;i<n_boxes;i++)
    {
       box_t *B= boxes[i];
       if (doc_x>=B->left && doc_x<=B->right &&
           doc_y>=B->top  && doc_y<=B->bottom)
        return B;
    }
    return 0;
}
#line 905 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

void GraphView::draw_selection(FXDCWindow *dc)
{
   if (selected_box && box_visible(selected_box)) 
   {
      int X,Y,W,H;
      dc->setForeground(FXRGB(0,0,0));
      dc->setLineWidth(5);
      box_screen_coords(selected_box, &X, &Y, &W, &H);
      dc->drawRectangle(X,Y, W, H);
   }
}

#line 924 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

int GraphView::box_visible(box_t *B)
{
   int Wscr, Hscr;
   Wscr= getWidth()*shik;
   Hscr= getHeight()*shik;
   if (B->left   >= shik*pos_x + Wscr) return 0;
   if (B->right  <  shik*pos_x )       return 0;
   if (B->top    >= shik*pos_y + Hscr) return 0;
   if (B->bottom <  shik*pos_y )       return 0;
   return 1;
}

void GraphView::box_screen_coords
  (box_t *B, int *X, int *Y, int *W, int *H)
{
   screen_coords(B->left, B->top, X,Y);
   *W= (B->right-B->left+1)/shik;
   *H= (B->bottom-B->top+1)/shik;
}
#line 952 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

void GraphView::select_box(box_t *B)
{
   if (B==selected_box) return;
   if (selected_box) update_box(selected_box, TRUE);
   selected_box= B;
   if (selected_box) update_box(selected_box, TRUE);
}

#line 970 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

void GraphView::update_box(box_t *B, int borders)
{
  int X,Y,W,H;
  if (box_visible(B)) {
   box_screen_coords(B, &X,&Y, &W, &H);
   if (borders) { X-=5; Y-=5; W+= 10; H+= 10; }
   update(X,Y,W,H);
  }
}

#line 991 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

void GraphView::click_action(int x,int y)
{
    box_t *B;
    int a[2];

    B= find_box_screen(x,y);
    if (B) {
      if (target)
        target->tryHandle(this, FXSEL(SEL_COMMAND,message+ID_CLICK_NODE), B);
      return ;
    }
    document_coords(x,y, a+0, a+1);
    if (target)
       target->tryHandle(this, FXSEL(SEL_COMMAND,message+ID_CLICK_SPACE), a);
}

#line 1015 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
void GraphView::set_box_color(box_t *B, FXColor color)
{
  B->color= color;
  if (box_visible(B)) {
     if (B==selected_box) update_box(B,TRUE);
     else update_box(B,FALSE);
  }
  modified= 1;
}

#line 1074 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
void GraphView::edit_text(box_t *B)
{
  int X,Y;
  int TEW, TEH;
  int selfW, selfH;
  screen_coords(B->left, B->top, &X, &Y);
  if (X<0) X=0;
  if (Y<0) Y=0;

  TEW= text_frame->getWidth();
  TEH= text_frame->getHeight();

  selfW= getWidth();
  selfH= getHeight();

  if (X+TEW>selfW) X= selfW-TEW;
  if (Y+TEH>selfH) Y= selfH-TEH;
  
  if (X<0) X=0;
  if (Y<0) Y=0;

  text_frame->setX(X); text_frame->setY(Y);
  text_frame->show();
  node_text->setFocus();

  node_text->setText(B->text);
  node_text->selectAll();

  editing_box= B;
}
#line 1119 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

long GraphView::cancel_nodetext(FXObject* ob,FXSelector sel,void* ptr)
{
   editing_box= 0;
   text_frame->hide();
   return 1;
}

long GraphView::ok_nodetext(FXObject* ob,FXSelector sel,void* ptr)
{
  char *text;
  text_frame->hide();
  if (editing_box) {
    FXString contents;
    contents= node_text->getText();
    text= (char*) contents.text();
    set_text(editing_box, text);
    editing_box= 0;
  }
  return 1;
}
#line 1151 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

void GraphView::layout_text(box_t *box, int X,int Y)
{
  char** words;
  int nwords;
  int *widths;
  char **rows;
  int i;
  int nrows;
  double scale;

again:
  words= split_words(box->text);
  for(nwords=0;words[nwords];nwords++)  ;
  if (!nwords) {
     free(words);
     free(box->text);
     box->text= strdup("Node");
     goto again;
  }

  widths= (int*) alloca(nwords*sizeof(int));
  for(i=0;i<nwords;i++) 
     widths[i]= default_font->getTextWidth(words[i]);

  rows= text_layout_square(words, nwords, widths,
                      default_font_space, default_font_height);
  
  for(nrows=0;rows[nrows];nrows++) ;

  int W_display_text, H_display_text;
  W_display_text= default_font->getTextWidth(rows[0]);
  for(i=1;i<nrows;i++)
    W_display_text= max(W_display_text,default_font->getTextWidth(rows[i]));

  H_display_text= default_font_height * nrows;

  int W_display= W_display_text+ 20;  // FIXME: 20 is padding
  int H_display= H_display_text+ 20;  // it should be set somewhere else

  scale= box->font_size/120.0 * 10.0;
  int W, H;
  W= W_display * scale;
  H= H_display * scale;

  box->left= X - W/2;
  box->right= X+W-W/2;
  box->top= Y-H/2;
  box->bottom= Y+H-H/2;
  box->rows= rows;
  box->text_x= box->left + 10*scale; // 10 is half the padding here. FIXME
  box->text_y_baseline= box->top + (default_font_ascent+10)*scale; // ditto

  free(words);
}

#line 1217 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

void GraphView::set_text(box_t *box, char *text)
{
  box_t OLD;
  OLD= *box;

  box->text= strdup(text);
  
  layout_text(box, ((double)box->left+box->right)/2,
                   ((double)box->top+box->bottom)/2);

  update_box(&OLD, TRUE);
  update_box(box, TRUE);
  free(OLD.text);
  free(OLD.rows);
  update_max_coords(box);
  modified= 1;
}

#line 1249 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

long GraphView::nodetext_key(FXObject* ob,FXSelector sel,void* ptr)
{
   FXEvent *event= (FXEvent*) ptr;
   if (event->state!=0) return 0;
   if (event->code==KEY_Return || event->code==KEY_KP_Enter)
     { ok_nodetext(ob,sel,ptr); return 1;}
   if (event->code==KEY_Escape)
     { cancel_nodetext(ob,sel,ptr); return 1;}
   return 0;
}

#line 1269 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
void GraphView::remove_box(box_t *B)
{
   int i;
   int found= 0;
   if (B==editing_box) return ;
   for(i=0;i<n_boxes;i++)
      if (boxes[i]==B) {
       boxes[i]= boxes[n_boxes-1];
       n_boxes--;
       found= 1;
       break;
      }
   if (!found) return ;
   update_box(B, TRUE);
   free(B->text);
   free(B->rows);
   free(B);
   if (B==selected_box) selected_box= 0;
   modified= 1;
   // FIXME: do the max/min stuff
}
#line 1304 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
void GraphView::parse_input
     (FILE *f, box_t ***Rboxes, int *Rnboxes,int *Rsboxes)
{
  unsigned char buf[2000]; int len,cursor; unsigned char chr;
  unsigned int acc;
#line 1367 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
  char *textptr= 0;
#line 1381 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
  box_t *B= 0;
  int nbox, sbox; box_t **box_array;
  nbox= 0; sbox= 50; box_array= (box_t**) malloc(sizeof(box_t*)*sbox);
#line 1392 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
  int nrows;
#line 1407 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
  char **rows = 0;
#line 1310 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

  cursor= len= 0;
  acc= 0;
  while(1) {
    if (cursor==len) {
      len= fread(buf,1, sizeof(buf), f);
      if (len<=0) break;
      cursor= 0;
    }
    chr= buf[cursor++];
    switch(chr)
    {
#line 1333 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
     case '0': case '1': case '2': case '3': case '4':
     case '5': case '6': case '7': case '8': case '9':
        acc= (acc<<4) | (chr-'0');
        break;
     case 'a': case 'b': case 'c': case 'd': case 'e': case 'f':
        acc= (acc<<4) | (chr-'a'+10);
        break;
#line 1343 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
     case 'F': if (B) B->font_size= acc; acc= 0; break;
     case 'L': if (B) B->left= acc; acc= 0; break;
     case 'R': if (B) B->right= acc; acc= 0; break;
     case 'T': if (B) B->top= acc; acc= 0; break;
     case 'B': if (B) B->bottom= acc; acc=0; break;
     case 'X': if (B) B->text_x= acc; acc=0; break;
     case 'Y': if (B) B->text_y_baseline= acc; acc=0; break;
#line 1354 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
     case 'C': if (B) B->color= FXRGB( (acc>>16)&0xff,
                                       (acc>>8) & 0xff, acc &0xff);
               acc= 0; break;
#line 1362 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
     case 'S': if (B) { textptr= B->text= (char*) malloc(acc); } acc= 0; break;
     case '+': if (textptr) *(textptr++)= acc; acc=0; break;
#line 1371 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
     case 'G':
       B= (box_t*)malloc(sizeof(box_t));
       if (nbox==sbox) 
       {
         sbox+= sbox/2;
         box_array= (box_t**) realloc(box_array, sizeof(box_t*)*sbox);
       }
       box_array[nbox++]= B;
       break;
#line 1390 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
     case 'N': nrows= acc; acc=0; break;
#line 1398 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
  case 'w':
    if (B) { 
       B->rows= (char**) malloc((nrows+1)*sizeof(char*)+acc);
       textptr= (char*) B->rows + (nrows+1)*sizeof(char*);
       B->rows[nrows]= 0;
       rows= B->rows;
    }
    acc= 0; break;
#line 1413 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
     case 'r': if (rows) *(rows++)= textptr; break;
#line 1323 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
    }
  }
  *Rboxes= box_array; *Rnboxes= nbox; *Rsboxes= sbox;
}
#line 1432 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

void GraphView::output_box(FILE *f,box_t *B)
{
  fprintf(f, "G%xF%xL%xR%xT%xB%xX%xY",
          B->font_size, B->left, B->right, B->top, B->bottom,
          B->text_x, B->text_y_baseline);
  fprintf(f, "%xC", (FXREDVAL(B->color) << 16) |
                    (FXGREENVAL(B->color)<<8 ) | 
                     FXBLUEVAL(B->color));
  fprintf(f,"%xS", strlen(B->text)+1);
  output_chars(f,B->text, strlen(B->text)+1);
  int i,nrows=0, S=0;
  for(i=0;B->rows[i];i++)
  {
    S+= strlen(B->rows[i])+1;
    nrows++;
  }
  fprintf(f,"%xN%xw", nrows, S);
  for(i=0;B->rows[i];i++)
  {
    fprintf(f,"r");
    output_chars(f,B->rows[i], strlen(B->rows[i])+1);
  }
}
#line 1462 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"
void GraphView::output_chars(FILE *f, char *str, int len)
{
  int i;
  for(i=0;i<len;i++)
    fprintf(f,"%x+", (unsigned char)str[i]);
}
#line 1479 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

void GraphView::load_file(FILE *f)
{
  box_t **new_boxes;
  int new_n_boxes, new_s_boxes;
  int i;
  parse_input(f, &new_boxes, &new_n_boxes, &new_s_boxes);

  for(i=0;i<n_boxes;i++)
  {
    free(boxes[i]->text);
    free(boxes[i]->rows);
    free(boxes[i]);
  }
  free(boxes);

  boxes= new_boxes; n_boxes= new_n_boxes; s_boxes= new_s_boxes;
  max_x= max_y= INT_MIN; min_x= min_y= INT_MAX;

  for(i=0;i<n_boxes;i++)
  {
    if (boxes[i]->left<min_x) min_x= boxes[i]->left;
    if (boxes[i]->right>max_x) max_x= boxes[i]->right;
    if (boxes[i]->top<min_y) min_y= boxes[i]->top;
    if (boxes[i]->bottom>max_y) max_y= boxes[i]->bottom;
  }
  
  shik= 10.0;
  if (n_boxes)
  {
    pos_x= ((double) min_x + max_x)/2/shik-getWidth()/2;
    pos_y= ((double) min_y + max_y)/2/shik-getHeight()/2;
  }
  update();
  update_scroller();
}

void GraphView::save_file(FILE *f)
{
  int i;
  for(i=0;i<n_boxes;i++)
    output_box(f, boxes[i]);
}
#line 1542 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

void GraphView::clear_all()
{
  int i;
  for(i=0;i<n_boxes;i++)
  {
   box_t *B= boxes[i];
   free(B->text);
   free(B->rows);
   free(B);
  }
  n_boxes= 0;
  selected_box= 0;
  editing_box= 0;
  max_x= max_y= INT_MIN; min_x= min_y= INT_MAX;
  update();
  update_scroller();
}
#line 1571 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

void GraphView::rescale_box(box_t *B, double fact)
{
  if (fact<0.05) fact= 0.05;
  if (fact>1.5) fact= 1.5;

  double center_x, center_y;
  box_t OLD;
  OLD= *B;

  center_x= ((double) B->left + B->right)/2;
  center_y= ((double) B->top + B->bottom)/2;

  B->left= (B->left - center_x)*fact + center_x;
  B->right= (B->right - center_x)*fact + center_x;
  B->text_x= (B->text_x - center_x)*fact + center_x;

  B->top= (B->top-center_y)*fact+center_y;
  B->bottom= (B->bottom-center_y)*fact+center_y;
  B->text_y_baseline= (B->text_y_baseline-center_y)*fact+center_y;

  B->font_size *= fact;

  update_box(&OLD, TRUE);
  update_box(B, TRUE); // in fact, only one of these is needed since
                       // they occupy the same space and one of them is larger
}
 

#line 43 "/home/dodo/SFP/zooming_stickies-1.0/src/mouse.u"

long CLASSNAME::onLeftBtnPress(FXObject* ob,FXSelector sel,void* ptr)
{
  FXEvent *event= (FXEvent*) ptr;
  int event_x= event->win_x, event_y= event->win_y;

  mouse_down = 1;
  last_mouse_x= event_x; last_mouse_y= event_y;
  click_mouse_x= event_x; click_mouse_y= event_y;

  return 1;
}

#line 60 "/home/dodo/SFP/zooming_stickies-1.0/src/mouse.u"

long CLASSNAME::onLeftBtnRelease(FXObject* ob,FXSelector sel,void* ptr)
{

  FXEvent* event=(FXEvent*)ptr;
  int event_x= event->win_x, event_y= event->win_y;
  int far;

  int dx= event_x-click_mouse_x;
  int dy= event_y-click_mouse_y;

  far= (dx*dx+dy*dy) >= 25;

  if (!mouse_down) goto done;
  mouse_down= 0;

  if (!far && event->click_button==LEFTBUTTON && event->click_count==1) {
     click_action(event_x, event_y);
     goto done;
  }
  if (!far && event->click_button==LEFTBUTTON && event->click_count==2) {
     doubleclick_action(event_x, event_y);
     goto done;
  }
done:
  dragging= 0;
  mouse_release_action();
  return 1;
}

#line 94 "/home/dodo/SFP/zooming_stickies-1.0/src/mouse.u"

long CLASSNAME::onMotion(FXObject* ob,FXSelector sel,void* ptr)
{
  if (!mouse_down) return 1;
  FXEvent* event=(FXEvent*)ptr;
  int event_x= event->win_x, event_y= event->win_y;
  if (dragging==0) {
    if (drag_start(last_mouse_x, last_mouse_y))
      dragging= 1;
    else dragging= 2;
  }
  if (dragging==2) return 1;

  motion_action(last_mouse_x, last_mouse_y, event_x, event_y);

  last_mouse_x= event_x; last_mouse_y= event_y;

  return 1;
}

#line 147 "/home/dodo/SFP/zooming_stickies-1.0/src/graphview.u"

