/* This file is part of zooming_stickies.

   Copyright 2012 Sukru Cinar

   Distributed under the GPLv3 licence. Please see the file 
   'gpl-3.0.txt' for more details. */

#define gui_set_text(X,Y) \
 do {typeof(X)* Z= &(X); Z->cls->set_text(Z,Y);} while(0)
#define gui_get_text(X) \
 ({typeof(X)* _Z= &(X); char *_K= _Z->cls->get_text(_Z); _K;})
#define gui_set_value(X,Y) \
 do {typeof(X)* Z= &(X); Z->cls->set_value(Z,Y);} while(0)

#define gui_list_append(X, ...) \
 do { typeof(X)* Z= &(X); Z->cls->append_item(Z, __VA_ARGS__ ); } while(0)

#define gui_list_get_selected(X,Y) \
 ({ typeof(X)* Z= &(X); int _K= Z->cls->get_selected(Z,Y); _K; })

#define gui_print(X, ...) \
 do { typeof(X)* Z= &(X); Z->cls->print(Z, __VA_ARGS__ ); } while(0)

#define gui_clear(X) \
 do { typeof(X)* Z= &(X); Z->cls->clear(Z); } while(0)

 


 
typedef struct gui_button gui_button_t;

typedef struct {
  void (*set_text)(struct gui_button *,const char *);
} gui_button_class_t;

struct gui_button {
  gui_button_class_t *cls;
  void *widget;
};


typedef struct gui_label gui_label_t;

typedef struct {
  void (*set_text)(struct gui_label *,char *);
} gui_label_class_t;

struct gui_label {
  gui_label_class_t *cls;
  void *widget;
};



 typedef struct gui_text_viewer gui_text_viewer_t;

 typedef struct {
    void (*clear)(gui_text_viewer_t *);
    void (*set_text)(gui_text_viewer_t *,const char*);
 } gui_text_viewer_class_t;

 struct gui_text_viewer {
    gui_text_viewer_class_t *cls;
    void *widget;
 };



#ifdef __cplusplus
extern "C" {
#endif

void gui_init(int *argc,char **argv);
void gui_run();
void gui_flush();

#ifdef __cplusplus
}
#endif
 

typedef struct {
  void *self;
  
 void* scroller;

 gui_button_t color0;

 gui_button_t color1;

 gui_button_t color2;

 gui_button_t color3;

 gui_button_t color4;

 gui_button_t color5;

 gui_button_t color6;

 gui_button_t color7;

 gui_button_t color8;

 

 

 

 

 

 

 

 

 


 void* graph;

 gui_label_t status_bar;


} gui_fracmain_t;

#ifdef __cplusplus
extern "C" {
#endif

gui_fracmain_t *gui_c_fracmain();

#ifdef __cplusplus
}
#endif



typedef struct {
  void *self;
  

 gui_text_viewer_t text;


} gui_help_t;

#ifdef __cplusplus
extern "C" {
#endif

gui_help_t *gui_c_help();

#ifdef __cplusplus
}
#endif





#define gui_get_value(X, ...) do { typeof(X)* _Z= &(X); _Z->cls->get_value(_Z, __VA_ARGS__ ); } while(0)

 #define gui_execute(X) ({typeof(X)* _Z= &(X); _Z->cls->execute(_Z); })

#define gui_close(X) do { typeof(X)* _Z= &(X); _Z->cls->close(_Z); } while(0)

#define gui_get_current(X, ...) ({ typeof(X)* _Z= &(X); _Z->cls->get_current(_Z, __VA_ARGS__ ); })
#define gui_set_current_file(X, ...) do { typeof(X)* _Z= &(X); _Z->cls->set_current_file(_Z, __VA_ARGS__ ); } while(0)

#define gui_set_current_dir(X, ...) do { typeof(X)* _Z= &(X); _Z->cls->set_current_dir(_Z, __VA_ARGS__ ); } while(0)

#define gui_append(X, ...) do { typeof(X)* _Z= &(X); _Z->cls->append(_Z, __VA_ARGS__ ); } while(0)

#define gui_remove(X, ...) do { typeof(X)* _Z= &(X); _Z->cls->remove(_Z, __VA_ARGS__ ); } while(0)

#define gui_clear_selection(X) do { typeof(X)* _Z= &(X); _Z->cls->clear_selection(_Z); } while(0)

#define gui_select_item(X, ...) do { typeof(X)* _Z= &(X); _Z->cls->select_item(_Z, __VA_ARGS__ ); } while(0)


